    package RegLocation.Client;

    import RegLocation.Lib.*;

    import java.io.IOException;
    import java.net.SocketAddress;
    import java.util.HashMap;
    import java.util.Vector;

    public class MarkProcessingPool
    {
        Vector<Integer> pool;
        Vector<Integer> inProcess;
        Vector<Mark> MAL;
        HashMap<Integer, MarkStates> colors;
        SilhouetteChannel channel;

        public MarkProcessingPool(HashMap<Integer, MarkStates> mcolors, Vector<Mark> mal,SocketAddress lsckAddr)
        {
            this.colors  = mcolors;
            this.MAL     = mal;
            this.pool    = new Vector<Integer>();
            this.inProcess = new Vector<Integer>();
            this.channel = new SilhouetteChannel(lsckAddr);


            Thread senderTH = new Thread(new Runnable() {
                @Override
                public void run()
                {
                    while(true)
                    {
                        Mark[] MAL_Array = MAL.toArray(new Mark[MAL.size()]);
                        Integer[] pool_array = pool.toArray(new Integer[pool.size()]);
                        for(Integer hash : pool_array)
                        {
                            Mark found = null;
                            for(Mark i : MAL)
                                if(i.hashCode() == hash)
                                {
                                    found = i;
                                    break;
                                }

                            Request myRequest = new Request(found,SilhouetteComponent.R);
                           // pool.remove((Integer) myRequest.MarkHashCode);
                          //  inProcess.add(myRequest.MarkHashCode);

                            try
                            {
                                channel.sendRequest(myRequest);
                            }
                            catch (IOException ex)
                            {
                                ex.printStackTrace();
                            }
                        }

                        try
                        {
                            Thread.sleep(100);
                        }
                        catch (InterruptedException ex)
                        {
                            Thread.currentThread().interrupt();
                        }
                    }
                }});

                Thread PoolProcessing = new Thread(new Runnable()
                    {
                        @Override
                        public void run()
                        {
                            while(true)
                            {
                                    Response response = channel.receiveResponse();

                                    if(response != null)
                                    {
                                        if((float)response.R != SilhouetteComponent.R)
                                           return;
                                           MarkStates state;
                                           if(response.InRegionResult)
                                            state = MarkStates.InRegion;
                                           else
                                            state = MarkStates.OutOfRegion;

                                           colors.put((Integer) response.MarkHashCode, state);
                                           pool.remove((Integer)response.MarkHashCode);
                                    }
                                    try
                                    {
                                        Thread.sleep(100);
                                    }
                                    catch (InterruptedException eex)
                                    {
                                        Thread.currentThread().interrupt();
                                    }
                            }
                        }
                    });

            PoolProcessing.start();
            senderTH.start();
        }

        public void addMarkInPool(int MarkHashCode)
        {
            pool.add(MarkHashCode);
        }

    }
