package RegLocation.Lib;

import java.io.*;

public class Response implements Serializable
{
    public int MarkHashCode;
    public boolean InRegionResult;
    public double R;

    /**
     *
     * @param MHC Mark HashCode
     * @param IRR Result of execution InRegion
     * @param R   Current R value
     */
    public Response(int MHC, boolean IRR,double R)
    {
        this.MarkHashCode   = MHC;
        this.InRegionResult = IRR;
        this.R              = R;
    }

    public static Response toResponse(InputStream BytesStream)
    {
        Response ret = null;
        try
        {
            ObjectInputStream deserialize = new ObjectInputStream(BytesStream);
            ret = (Response)deserialize.readObject();

        }
        catch (IOException ex)
        {
            return null;
        }
        catch (ClassNotFoundException ex)
        {
            ex.printStackTrace();
        }

        return ret;
    }

    public void getBytesStream(OutputStream outStream)
    {
        try
        {
            ObjectOutputStream serializer = new ObjectOutputStream(outStream);
            serializer.writeObject(this);
        }
        catch (IOException ex)
        {
            ex.printStackTrace();
        }

        return;
    }
}
