package RegLocation.Server;

import RegLocation.Lib.Mark;

import java.lang.Math;
public class Silhouette
{

    public static boolean InRegion(Mark mk,float R)
    {
        float[] coords = mk.getCoord();
        return Silhouette.InRegion(coords[0],coords[1],R);
    }

    public static boolean InRegion(float x,float y,float R)
    {
        int ret = 0;


        if(x >= 0)
            if ( y >= 0 )
                ret = 0;
            else
                ret = ForthQuater(x,y,R);
        else
        if ( y > 0 )
            ret = SndQuater(x,y,R);
        else
            ret = ThrQuater(x,y,R);
        return ret == 1;
    }

    static int SndQuater(float x,float y,float R)
    {
        int ret = 0;
        if((x> -R && x < 0) && ( R/2 > y && y > 0  ) )
            ret = 1;
        return ret;
    }

    static int ThrQuater(float x,float y,float R)
    {
        int ret = 0;
        float val = (-1)*x -  R;
        if( y > val )
            ret = 1;
        return ret;
    }

    static int ForthQuater(float x,float y,float R)
    {
        int ret = 0;
        float val = (float)Math.pow(x,2) + (float)Math.pow(y,2);
        if ( Math.pow(R/2,2) > val  )
            ret = 1;
        return ret;
    }
}
